/* Copyright (C) 2000 MySQL AB & MySQL Finland AB & TCX DataKonsult AB
   
   This file was taken from MySQL 3.23.11 sources and modified for
   use in Colibri.SQL by SWsoft. Changes are (C) 2000, 2001, SWsoft.
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
   
   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA */


/* Defines neaded for dialogs */

#include "resource.h"

#define MAXPATHLEN      (255+1)           // Max path length
#define MAXKEYLEN       (15+1)            // Max keyword length
#define MAXDESC         (255+1)           // Max description length
#define MAXDSNAME       (32+1)            // Max data source name length
#define MAXSERVER	(60+1)
#define MAXUSER		(16+1)
#define MAXPASSWORD	(16+1)
#define MAXSTMT		(255+1)

/* Attribute key indexes (into an array of Attr structs, see below */

#define KEY_DSN 		0
#define KEY_DESC		1
#define KEY_DB			2
#define KEY_SERVER		3
#define KEY_USER		4
#define KEY_PASSWORD	5
#define KEY_PORT        6
#define KEY_STMT		7
#define KEY_FLAG		8
#ifndef SWSOFT
#define NUMOFKEYS		9	// Number of keys supported
#else
#define KEY_SYSDB		9
#define NUMOFKEYS		10	// Number of keys supported
#endif
#define NUMOFBITS		18	/* Number of different options */

typedef struct tagAttr {
	BOOL  fSupplied;
	char  szAttr[MAXPATHLEN];
} Attr, FAR * LPAttr;

typedef struct tagSETUPDLG {
  SQLHWND	hwndParent; 			// Parent window handle
  LPCSTR	lpszDrvr;		// Driver description
  Attr	aAttr[NUMOFKEYS];		// Attribute array
  char	szDSN[MAXDSNAME];		// Original data source name
  BOOL	fNewDSN;			// New data source flag
  BOOL	fDefault;			// Default data source flag
  ulong config_flags;			/* Flags to affect myodbc behavour */
#ifdef SWSOFT
  char  szSysDb[MAXPATHLEN];
#endif
} SETUPDLG, FAR *LPSETUPDLG;


BOOL FAR PASCAL DriverConnectProc(HWND hdlg,WORD wMsg,WPARAM wParam,LPARAM lParam);
void INTFUNC ParseAttributes (LPCSTR lpszAttributes, LPSETUPDLG lpsetupdlg);
#ifdef SWSOFT_LIB
void set_attributes(LPSETUPDLG lpsetupdlg,BOOL bSetup);
#else
void set_attributes(LPSETUPDLG lpsetupdlg);
#endif
